
package com.madhu.xml;

import java.io.*;

import org.w3c.dom.*;
import org.w3c.dom.traversal.*;
import javax.xml.parsers.*;

public class IteratorApp {
	protected DocumentBuilder docBuilder;
	protected Document document;
	protected Element root;

	public IteratorApp() throws Exception {
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		docBuilder = dbf.newDocumentBuilder();
		DOMImplementation domImp = docBuilder.getDOMImplementation();
		if (domImp.hasFeature("Traversal", "2.0")) {
			System.out.println("Parser supports Traversal");
		}
	}

	public void parse(String fileName) throws Exception {
		document = docBuilder.parse(new FileInputStream(fileName));
		root = document.getDocumentElement();
		System.out.println("Root element is " + root.getNodeName());
	}

	public void iterate() {
		NodeIterator iter =
		((DocumentTraversal)document).createNodeIterator(
			root, NodeFilter.SHOW_ELEMENT,
			new NameNodeFilter("book"), true);

		Node n = iter.nextNode();
		while (n != null) {
			System.out.println(n.getFirstChild().getNodeValue());
			n = iter.nextNode();
		}
	}

	public static void main(String args[]) throws Exception {
		IteratorApp ia = new IteratorApp();
		ia.parse(args[0]);
		ia.iterate();
	}
}
