
package com.madhu.xml;

import java.io.*;

import org.w3c.dom.*;
import javax.xml.parsers.*;

public class SimpleWalker {
	protected DocumentBuilder docBuilder;
	protected Element root;

	public SimpleWalker() throws Exception {
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		docBuilder = dbf.newDocumentBuilder();
		DOMImplementation domImp = docBuilder.getDOMImplementation();
		if (domImp.hasFeature("XML", "2.0")) {
			System.out.println("Parser supports extended interfaces");
		}
	}

	public void parse(String fileName) throws Exception {
		Document doc = docBuilder.parse(new FileInputStream(fileName));
		root = doc.getDocumentElement();
		System.out.println("Root element is " + root.getNodeName());
	}

	public void printAllElements() throws Exception {
		printElement("", root);
	}

	public void printElement(String indent, Node aNode) {
		if (aNode.getNodeType() == Node.TEXT_NODE) {
			System.out.println(indent + aNode.getNodeValue());
		} else {
			System.out.println(indent + "<" + aNode.getNodeName() + ">");
			Node child = aNode.getFirstChild();
			while (child != null) {
				printElement(indent + "\t", child);
				child = child.getNextSibling();
			}
			System.out.println(indent + "</" + aNode.getNodeName() + ">");
		}
	}

	public static void main(String args[]) throws Exception {
		SimpleWalker sw = new SimpleWalker();
		sw.parse(args[0]);
		sw.printAllElements();
	}
}
