
import java.io.*;
import java.util.*;
import javax.xml.bind.*;
import javax.xml.marshal.*;


public class LibraryApp {
	protected Library myLibrary;

	public LibraryApp() {
		myLibrary = new Library();
	}

	public static void main(String[] args) throws Exception {
		LibraryApp la = new LibraryApp();

		la.readXML("library.xml");
		la.addBook();
		la.validate();
		la.writeXML("new_library.xml");
	}

	public void readXML(String fileName) throws Exception {
		System.out.println("Reading " + fileName);
		FileInputStream fIn = new FileInputStream(fileName);
		try {
			myLibrary = myLibrary.unmarshal(fIn);
		} finally {
			fIn.close();
		}
		System.out.println(myLibrary);
	}

	public void addBook() {
		List entryList = myLibrary.getContent();
		for (ListIterator i = entryList.listIterator(); i.hasNext();) {
			Object element = i.next();
			if (element instanceof Science) {
				Book qmBook = new Book();
				qmBook.setAuthor("Eisberg, Resnick");
				qmBook.setContent("Quantum Mechanics");
				Science sb = (Science) element;
				List sl = sb.getBook();
				sl.add(qmBook);
				break;
			}
		}
	}

	public void validate() throws Exception {
		myLibrary.validate();
	}

	public void writeXML(String fileName) throws Exception {
		System.out.println("Writing " + fileName);
		FileOutputStream fOut = new FileOutputStream(fileName);
		try {
			myLibrary.marshal(fOut);
		} finally {
			fOut.close();
		}
	}
}
