
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.InvalidContentObjectException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.PredicatedLists;
import javax.xml.bind.PredicatedLists.Predicate;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.ValidatableObject;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


public class Biography
    extends MarshallableObject
    implements Element
{

    private List _Book = PredicatedLists.createInvalidating(this, new BookPredicate(), new ArrayList());
    private PredicatedLists.Predicate pred_Book = new BookPredicate();

    public List getBook() {
        return _Book;
    }

    public void deleteBook() {
        _Book = null;
        invalidate();
    }

    public void emptyBook() {
        _Book = PredicatedLists.createInvalidating(this, pred_Book, new ArrayList());
    }

    public void validateThis()
        throws LocalValidationException
    {
        if (_Book == null) {
            throw new MissingContentException("book");
        }
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
        for (Iterator i = _Book.iterator(); i.hasNext(); ) {
            v.validate(((ValidatableObject) i.next()));
        }
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("biography");
        for (Iterator i = _Book.iterator(); i.hasNext(); ) {
            m.marshal(((MarshallableObject) i.next()));
        }
        w.end("biography");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("biography");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
        {
            List l = PredicatedLists.create(this, pred_Book, new ArrayList());
            while (xs.atStart("book")) {
                l.add(((Book) u.unmarshal()));
            }
            _Book = PredicatedLists.createInvalidating(this, pred_Book, l);
        }
        xs.takeEnd("biography");
    }

    public static Biography unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static Biography unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static Biography unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((Biography) d.unmarshal(xs, (Biography.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof Biography)) {
            return false;
        }
        Biography tob = ((Biography) ob);
        if (_Book!= null) {
            if (tob._Book == null) {
                return false;
            }
            if (!_Book.equals(tob._Book)) {
                return false;
            }
        } else {
            if (tob._Book!= null) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((127 *h)+((_Book!= null)?_Book.hashCode(): 0));
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<biography");
        if (_Book!= null) {
            sb.append(" book=");
            sb.append(_Book.toString());
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        Dispatcher d = new Dispatcher();
        d.register("biography", (Biography.class));
        d.register("book", (Book.class));
        d.register("fiction", (Fiction.class));
        d.register("library", (Library.class));
        d.register("science", (Science.class));
        d.freezeElementNameMap();
        return d;
    }


    private static class BookPredicate
        implements PredicatedLists.Predicate
    {


        public void check(Object ob) {
            if (!(ob instanceof Book)) {
                throw new InvalidContentObjectException(ob, (Book.class));
            }
        }

    }

}
