
package com.madhu.xml;

import java.io.*;
import java.util.*;
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;

import org.jdom.*;
import org.jdom.output.*;

public class XMLServlet extends HttpServlet {
	protected Connection connection;

	public void init() {
		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
			connection = DriverManager.getConnection("jdbc:odbc:worldfactbook");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response)
		throws IOException {

		ServletConfig config = getServletConfig();
		PrintWriter out = response.getWriter();
		response.setContentType("text/xml");
		try {
			String sql = request.getParameter("sql");
			Statement stat = connection.createStatement();
			ResultSet rs = stat.executeQuery(sql);
			ResultSetMetaData rsMeta = rs.getMetaData();
			int rowNumber = 1;
			Element root = new Element("resultset");
			root.setAttribute("query", sql);
			while (rs.next()) {
				Element row = new Element("row");
				row.setAttribute("index", Integer.toString(rowNumber));
				int nCols = rsMeta.getColumnCount();
				for (int i=1; i<=nCols; i+=1) {
					String colName = rsMeta.getColumnName(i);
					Element column = new Element(colName);
					column.addContent(rs.getString(i));
					row.addContent(column);
				}
				root.addContent(row);
				rowNumber += 1;
			}
			rs.close();
			stat.close();

			Document doc = new Document(root);

			XMLOutputter outputter = new XMLOutputter("\t", true);
			outputter.output(doc, out);
		} catch (Exception e) {
			e.printStackTrace(out);
		}
	}
}
